# mongo-swift

### Installation

```sh
$ npm install mongo-swift
```
```sh
$ pushd c:
$ cd c/Program Files/MongoDB/Server/3.2/bin
$ mongod --dbpath db
```


![08-03-2017 17-27-17](https://cloud.githubusercontent.com/assets/22218672/23704059/dc87603e-0424-11e7-8e7c-e0b223e52528.jpg)




![08-03-2017 17-43-30](https://cloud.githubusercontent.com/assets/22218672/23704442/c8580dd2-0426-11e7-92a9-3be7bea7553b.jpg)

### Usage

```javascript
import MongoSwift from 'mongo-swift';

var options = {
    databases: [
        'local',
        'network',
        'offline',
        'others',
        'admin',
        'online'
    ]
};


setTimeout(async() => {
    try {
        var users = await db.online.users.count();
        var messages = await db.online.messages.count();
        var commints = await db.online.commints.count();
        var pictures = await db.online.pictures.count();
        var posts = await db.online.posts.count();
        var statuses = await db.online.statuses.count();

        var oneUser = await db.online.users.findOne({});
        var allUsers = await db.online.users.find({}).toArray();

        console.log("Results => ",
            "\nUsers count =>", users,
            "\nMessages count =>", messages,
            "\nCommints count =>", commints,
            "\nPictures count =>", pictures,
            "\nPosts count =>", posts,
            "\nStatuses count =>", statuses,
            "\nAll users count =>\n", allUsers,
            "\none user =>\n", oneUser

        );
    }
    catch (error){
        console.log("Error => ", error);
    }
}, 5000);
```


### Results

![09-03-2017 16-43-27](https://cloud.githubusercontent.com/assets/22218672/23748937/8e4c9588-04e7-11e7-9151-33b19a2552ed.jpg)


