var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _asyncToGenerator = require('babel-runtime/helpers/async-to-generator')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _mongodb = require('mongodb');

var MongoDB = _interopRequireWildcard(_mongodb);

var _coleection = require('./coleection');

var _coleection2 = _interopRequireDefault(_coleection);

var MongoSwift = (function () {
    function MongoSwift(conections) {
        _classCallCheck(this, MongoSwift);

        this.url = 'mongodb://localhost:27017/';
        this.dbcolopt = conections;
        this.onInit();
    }

    _createClass(MongoSwift, [{
        key: 'onInit',
        value: _asyncToGenerator(function* () {
            try {
                if (!this.dbcolopt || this.dbcolopt.constructor !== Object) {
                    throw new Error('MongoDB options not found or invalid options.');
                }

                if (!this.dbcolopt.databases || this.dbcolopt.databases.constructor !== Array) {
                    throw new Error('Invalid format database names array.');
                }

                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = _getIterator(this.dbcolopt.databases), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var dbName = _step.value;

                        if (dbName.constructor !== String) {
                            throw new Error('Invalid format database names.');
                        }
                        this[dbName] = yield this.connect(dbName);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator['return']) {
                            _iterator['return']();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            } catch (error) {
                console.log(error);
                process.exit(1);
            }
        })
    }, {
        key: 'connect',
        value: _asyncToGenerator(function* (dbName) {
            try {
                var dbUrl = this.url + dbName;
                var db = yield MongoDB.MongoClient.connect(dbUrl);

                var collections = yield db.listCollections().toArray();

                var collects = {};
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                    for (var _iterator2 = _getIterator(collections), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                        var collection = _step2.value;

                        collects[collection.name] = yield (0, _coleection2['default'])(db, collection.name);
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2['return']) {
                            _iterator2['return']();
                        }
                    } finally {
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }

                return collects;
            } catch (error) {
                throw new Error('Error to connect to database. Database name is not registored.' + dbUrl);
            }
        })
    }]);

    return MongoSwift;
})();

exports['default'] = MongoSwift;
module.exports = exports['default'];