import * as MongoDB from 'mongodb';

import Collection from './coleection';

export default class MongoSwift {
    constructor(conections) {
        this.url = 'mongodb://localhost:27017/';
        this.dbcolopt = conections;
        this.onInit();
    }

    async onInit() {
        try {
            if (!this.dbcolopt || this.dbcolopt.constructor !== Object) {
                throw new Error('MongoDB options not found or invalid options.');
            }

            if (!this.dbcolopt.databases || this.dbcolopt.databases.constructor !== Array) {
                throw new Error('Invalid format database names array.');
            }

            for (let dbName of this.dbcolopt.databases) {
                if (dbName.constructor !== String) {
                    throw new Error('Invalid format database names.')
                }
                this[dbName] = await this.connect(dbName)
            }
        }
        catch (error) {
            console.log(error);
            process.exit(1);
        }
    }

    async connect(dbName) {
        try {
            var dbUrl = this.url + dbName;
            let db = await MongoDB.MongoClient.connect(dbUrl);

            let collections = await db.listCollections().toArray();

            var collects = {}
            for (let collection of collections) {
                collects[collection.name] = await Collection(db, collection.name);
            }
            return collects;
        }
        catch (error) {
            throw new Error('Error to connect to database. Database name is not registored.' + dbUrl);
        }
    }
}